{*******************************************************************************
  HiAsm stamp component builder v0.8 (autor - andrestudio <andrestudio@list.ru>)
  Component - CompareStreamRange
  Version - 1.0
  Autor - andrestudio
  E-mail - andrestudio72@yandex.ru
  Create - , 31.  2015, 12:04:27
  Description:       Stream
*******************************************************************************}

unit hiCompareStreamRange;

interface

uses Windows,Kol,Share,Debug;

type

 THICompareStreamRange = class(TDebug)
   private
   { Var methods variable }
     {        }
     fCompareSize: integer;
     {      Stream }
     fPosition: integer;
     {     }
     fAddress1: integer;
     {     }
     fAddress2: integer;
     {       }
     fByte1: integer;
     {      }
     fByte2: integer;

   { Property variable  }
     {   Stream1  . }
     fOffsetAddr1: integer;
     {   Stream2  . }
     fOffsetAddr2: integer;
     {    ,  -1  
            }
     fLength: integer;
     {  AutoStop = True   ,  False
         }
     fAutoStop: boolean;
     {     }
     st1,st2: PStream;
     {   }
     fValid: integer;
     {     HEX  }
     fHexOut: boolean;
     {      }
     fChkStreamFile1: boolean;
     fChkStreamFile2: boolean;
     {      }
     ftmp: integer;

     {       }
     procedure CompareStreamRange(var P1, P2:  Pointer;
                                  OffsetAddr1: cardinal;
                                  OffsetAddr2: cardinal;
                                  Length:      cardinal);
   public
   { Event points }
     _event_onTrue: THI_Event;
     _event_onFalse: THI_Event;
     _event_onCompare: THI_Event;
     _event_onError: THI_Event;
     _event_onMaxProgress: THI_Event;
     _event_onProgress: THI_Event;
     _event_onEnd: THI_Event;

   { Data points}
     { Stream 1   }
     _data_Stream1: THI_Event;
     { Stream 2   }
     _data_Stream2: THI_Event;
     {   Stream1  . }
     _data_OffsetAddr1: THI_Event;
     {   Stream2  . }
     _data_OffsetAddr2: THI_Event;
     {    ,  -1  
            }
     _data_Length: THI_Event;

   { Events }
     {           }
     procedure onCompare;
     {   }
     procedure onError(idx: byte);

   { Methods }
     {    Stream1  Stream2 }
     procedure _work_doCompare(var _Data: TData; Index: Word);

   { Methods from property }
     {   Stream1  . }
     procedure _work_doOffsetAddr1(var _Data: TData; Index: Word);
     {   Stream2  . }
     procedure _work_doOffsetAddr2(var _Data: TData; Index: Word);
     {    ,  -1       }
     procedure _work_doLength(var _Data: TData; Index: Word);

   { Var procedure }
     {     }
     procedure _var_Address1(var _Data: TData; Index: Word);
     {     }
     procedure _var_Address2(var _Data: TData; Index: Word);
     {       }
     procedure _var_Byte1(var _Data: TData; Index: Word);
     {      }
     procedure _var_Byte2(var _Data: TData; Index: Word);
     {    "Yes"  "No" }
     procedure _var_Valid(var _Data: TData; Index: Word);

   { Property }
     {   Stream1  . }
     property _prop_OffsetAddr1: integer  read fOffsetAddr1  write fOffsetAddr1;
     {   Stream2  . }
     property _prop_OffsetAddr2: integer  read fOffsetAddr2  write fOffsetAddr2;
     {    ,  -1  
            }
     property _prop_Length: integer  read fLength  write fLength;
     {  AutoStop = True   ,  False
       }
     property _prop_AutoStop: boolean  read fAutoStop  write fAutoStop;
     {     HEX  }
     property _prop_HexOut: boolean  read fHexOut  write fHexOut;
  end;

implementation

//uses DebugEx;

{       }
procedure THICompareStreamRange.CompareStreamRange(var P1, P2:  Pointer;
                                                   OffsetAddr1: cardinal;
                                                   OffsetAddr2: cardinal;
                                                   Length:      cardinal);
begin
  fValid := 0;   ftmp := 0;
  fPosition := 0;
  fCompareSize := fPosition + Length;
  //     ProgressBar
  _hi_onEvent(_event_onMaxProgress,Integer(Length));
  try
    //  
    if not fChkStreamFile1 then P1 := PChar(P1) + OffsetAddr1
      else st1.Position := OffsetAddr1;
    if not fChkStreamFile2 then P2 := PChar(P2) + OffsetAddr2
      else st2.Position := OffsetAddr2;

    while (fPosition < fCompareSize) do
      begin
      //    
      if not fChkStreamFile1 then fByte1 := Byte(P1^) else st1.read(fByte1,1);
      if not fChkStreamFile2 then fByte2 := Byte(P2^) else st2.read(fByte2,1);
      //  
      if not fChkStreamFile1 then fAddress1 := Integer(P1) else fAddress1 := st1.Position-1;
      if not fChkStreamFile2 then fAddress2 := Integer(P2) else fAddress2 := st2.Position-1;
      //    
      ftmp := fByte1 - fByte2;
      //    ,     onFalse,
      //       "AutiStop = True"
      if (ftmp <> 0) then
        begin
          _hi_onEvent(_event_onFalse);
          Inc(fValid);
          if fAutoStop = True then Break;
        end;
      //    
      if not fChkStreamFile1 then P1 := PChar(P1)+1;
      if not fChkStreamFile2 then P2 := PChar(P2)+1;
      fPosition := fPosition + 1;
      //  
      _hi_onEvent(_event_onCompare);
      //      Kbyte 
      if (fPosition mod 1024) = 0 then
        begin
          _hi_onEvent(_event_onProgress,fPosition);
          Applet.ProcessMessages;
        end;
     end;
     //     
     if fValid > 0 then onError(4) else _hi_onEvent(_event_onTrue);
     //   
     _hi_onEvent(_event_onEnd); _hi_onEvent(_event_onProgress,0);
   except
     onError(5);
   end;
end;

{           }
procedure THICompareStreamRange.onCompare;
begin
  _hi_onEvent(_event_onCompare);
end;

{   }
procedure THICompareStreamRange.onError;
begin
  case idx of
    0: _hi_onEvent(_event_onError, ' 1  "0"');
    1: _hi_onEvent(_event_onError, ' 2  "0"');
    2: _hi_onEvent(_event_onError, '  1');
    3: _hi_onEvent(_event_onError, '  2');
    4: _hi_onEvent(_event_onError, ' ' + Int2Str(fValid) + ' ');
    5: _hi_onEvent(_event_onError, '  ');
    6: _hi_onEvent(_event_onError, '1  ');
    7: _hi_onEvent(_event_onError, '2  ');
    8: _hi_onEvent(_event_onError, '   1');
    9: _hi_onEvent(_event_onError, '   2');
  end;
  _hi_onEvent(_event_onEnd);
end;

{    Stream1  Stream2 }
procedure THICompareStreamRange._work_doCompare;
var s1,s2: Integer;
    P1, P2: Pointer;
begin
  //  
  s1 := 0; s2 := 0; fChkStreamFile1 := False; fChkStreamFile2 := False;
  //    
  if not Assigned(_data_Stream1.Event) then  begin onError(6); Exit; end;
  if not Assigned(_data_Stream2.Event) then  begin onError(7); Exit; end;
  //  
  st1 := ToStreamEvent(_data_Stream1);
  st2 := ToStreamEvent(_data_Stream2);
  //    
  if not Assigned(st1) then  begin onError(8); Exit; end;
  if not Assigned(st2) then  begin onError(9); Exit; end;
  //  
  s1 := st1.Size; s2 := st2.Size;
  if (s1 = 0) then  begin onError(0); Exit; end;
  if (s2 = 0) then  begin onError(1); Exit; end;
  //    
  fLength := ReadInteger(_Data,_data_Length,_prop_Length);
  fOffsetAddr1 := ReadInteger(_Data,_data_OffsetAddr1,_prop_OffsetAddr1);
  fOffsetAddr2 := ReadInteger(_Data,_data_OffsetAddr2,_prop_OffsetAddr2);
  //       
  //      
  if fLength < 0 then
     if s1 < s2 then fLength := s1 else fLength := s2;
  //   
  if fOffsetAddr1 < 0 then fOffsetAddr1 := 0;
  if fOffsetAddr2 < 0 then fOffsetAddr2 := 0;
  //    
  if (fOffsetAddr1 + fLength) > s1 then begin onError(2); Exit; end;
  if (fOffsetAddr2 + fLength) > s2 then begin onError(3); Exit; end;
  //  
  P1 := st1.Memory;  P2 := st2.Memory;
  //     o 
  if Integer(P1) = 0 then fChkStreamFile1 := True;
  if Integer(P2) = 0 then fChkStreamFile2 := True;
  //  
  CompareStreamRange(P1,P2,fOffsetAddr1,fOffsetAddr2,fLength);
end;

{   Stream1  . }
procedure THICompareStreamRange._work_doOffsetAddr1;
begin
  fOffsetAddr1 := ToInteger(_Data);
end;

{   Stream2  . }
procedure THICompareStreamRange._work_doOffsetAddr2;
begin
  fOffsetAddr2 := ToInteger(_Data);
end;

{    ,  -1  
       }
procedure THICompareStreamRange._work_doLength;
begin
  fLength := ToInteger(_Data);
end;

{     }
procedure THICompareStreamRange._var_Address1;
var s: string;
begin
  if fHexOut then
    begin
      s := Format('0x%010X', [fAddress1]);
      dtString(_Data,s);
    end else
      dtInteger(_Data, fAddress1);
end;

{     }
procedure THICompareStreamRange._var_Address2;
var s: string;
begin
  if fHexOut then
    begin
      s := Format('0x%010X', [fAddress2]);
      dtString(_Data,s);
    end else
      dtInteger(_Data, fAddress2);
end;

{       }
procedure THICompareStreamRange._var_Byte1;
var s: string;
begin
  if fHexOut then
    begin
      s := Format('%.2X', [fByte1]);
      dtString(_Data,s);
    end else
      dtInteger(_Data, fByte1);
end;

{      }
procedure THICompareStreamRange._var_Byte2;
var s: string;
begin
  if fHexOut then
    begin
      s := Format('%.2X', [fByte2]);
      dtString(_Data,s);
    end else
      dtInteger(_Data, fByte2);
end;

{    "Yes"  "No" }
procedure THICompareStreamRange._var_Valid(var _Data: TData; Index: Word);
var s: string;
begin
  if ftmp <> 0 then s := 'No' else s := 'Yes';
  dtString(_Data,s);
end;

end.
